<template>
  <b-container>
    <HeaderVendeur />
  </b-container>
  <b-container>
    <div class="button d-flex justify-content-start">
      <GoBack />
    </div>
    <div class="background_bloc h-100" />
    <p v-if="messageError">
      {{ messageError }}
    </p>
    <b-row v-else>
      <b-col
        class="col-sm"
        sm="4"
      >
      <figure>
        <b-img 
          v-if="img"
          :src="url + img"
          alt=""
          class="w-100"
        />
        <b-img
          v-else
          :src="require('@/assets/images/noimg.png')"
          alt=""
          class="w-100"
        />
      </figure>
        <b-row class="d-flex pb-4">
          <b-col class="d-flex">
            <b-col
              v-for="img in produitImg"
              :key="img"
              class="col-sm img_details p-0"
            >
            <figure
              class="w-100 h-100">
              <b-img
                v-if="img != 'noimg'"
                :src="url + img"
                alt="aaaa"
                class="img_details w-100 h-100"
                @click="changeImg(img)"
              />
              <b-img
                v-else
                :src="require('@/assets/images/noimg.png')"
                alt=""
                class="img_details w-100 h-100"
                @click="changeImg(img)"
              />
            </figure>
            </b-col>
            <b-col
              v-for="idx in emptyImg"
              :key="idx"
              class="col-sm img_details"
            >
              <div />
            </b-col>
          </b-col>
        </b-row>
      </b-col>
      <b-col class="ml-6 col-sm col-lg-8 d-flex flex-column">
        <h1 class="title">
          {{ produit.titre }}
        </h1>
        <p>{{ produit.description }}</p>
        <p v-if="produit.quantite != 0">
          Quantité en stock : {{ produit.quantite }}
        </p>
        <p class="d-flex justify-content-end">
          {{ produit.prix }}€
        </p>

        <b-form
          v-if="store.isConnected"
          class="d-md-flex justify-content-end align-items-center mt-4"
        >
          <b-form-group class="mb-0 mx-2">
            <label>Quantité souhaitée : </label>
            <select
              v-if="produit.quantite != 0"
              v-model="selectedQuantite"
              class="form-select"
            >
              <option
                v-for="nb in produit.quantite"
                :key="nb"
                :value="nb"
                >
                {{ nb }}
              </option>       
            </select>
            <select 
              v-else
              class="form-select"
              v-model="selectedQuantite"
              >
              <option
              v-for="nb in quantite"
                :key="nb"
                :value="nb"
              >
                {{ nb }}
              </option>
            </select>
          </b-form-group>
          <button
            v-b-modal.modal-1
            class="submit btn-cta d-flex align-self-end mb-3"
            type="submit"
            @click="command()"
          >
            COMMANDER
          </button>
        </b-form>
        <div
          v-else
          class="d-flex align-items-center"
        >
          <router-link
            :to="{ name: 'Connexion'}"
            class="btn-cta m-1"
          >
            Se connecter pour commander
          </router-link>
        </div>
      </b-col>
    </b-row>
  </b-container>
  <b-modal
    id="modal-1"
    v-model="show"
    ok-title="Continuer"
    cancel-title="Annuler"
    @ok="makeCommand()"
  >
    {{ message }}
  </b-modal>
</template>

<script>
import HeaderVendeur from '@/components/HeaderVendeur.vue';
import GoBack from '@/components/GoBack.vue';
import axios from 'axios';
import { useStore } from '@/store/store';


export default {
    components: {
      HeaderVendeur,
      GoBack
    },

    data() {

      const url = process.env.VUE_APP_URL;
      let produit = [];
      let produitImg = [];

      return {
        produit,
        produitImg,
        url,
        img: '',
        emptyImg: '',
        messageError: '',
        message: '',
        selectedQuantite: 1,
        quantite: [1,2,3,4,5,6,7,8,9,10],
        store: useStore(),
        show: false
      }

    },

    watch: {
        '$route.params.id': function () {
            this.loadData();
        },
    },

    mounted() {
        
      this.loadData();

    },

    methods: {
      
      loadData(){
        let idProduit= this.$route.params.id;
        axios({
            method: 'get',
            url: this.url + "/api/produits/" + idProduit,
        })
        .then(res =>  {
            this.produit = res.data;
            if(res.data.mediaObjects[0] != undefined && res.data.mediaObjects[0] != ''){
              this.img = res.data.mediaObjects[0].contentUrl;
              res.data.mediaObjects.forEach(media => {
                this.produitImg.push(media.contentUrl);
                
              });
            } else {
                this.produitImg.push('noimg');
            }

            this.emptyImg = 3 - this.produitImg.length;
        })
        .catch(err => {
            console.log(err);
            this.messageError = 'Ce produit n\'est pas disponible.'

        })
      },

      changeImg(newImg) {
        this.img = newImg;
      },

      command(){
        this.message = 'Une notification de commande sera envoyée au vendeur qui vous contactera pour décider d\'un point de rendez-vous et des modalités de paiement. Voulez-vous continuer ?'
      },

      makeCommand(){
        axios.post(this.url + "/api/commandes",
                {
                    "utilisateur": "api/utilisateurs/" + this.store.user.id,
                    "date": new Date(),
                    "produit": "api/produits/" + this.$route.params.id,
                    "quantite": this.selectedQuantite,
                    "prix": this.produit.prix * this.selectedQuantite ,
                    "statut": "api/statuts/1",
                    "vendeur": "api/info_vendeurs/" + this.$route.params.idVendeur
                })
                .then(response => {
                  this.$router.push('/mes-commandes');
                })    
                .catch(err => {
                    console.log(err);
                })
      }
    }
  }
</script>

<style scoped lang="scss">
.img_details{
  object-fit: cover;
  &:hover {
    cursor: pointer;
  }
}

.form-select {
  display: inline;
  padding: 0.3rem;
}
</style>